using System;
using System.ComponentModel.Design;
class Program
{
    static void Funkcija(int t, long n, long k, long a)
    {
        if ( n % 2 == Math.Abs(a) % 2)
        {
            if (k == a)
            {
                Console.WriteLine("DA");
                if (t == 1) for (int i = 0; i < n; i++) Console.Write(a + " ");
            }
            else Console.WriteLine("NE");

        }
        else
        {
            if(k == a + 1)
            {
                Console.WriteLine("DA");
                if (t == 1) for (int i = 0; i < n; i++) Console.Write(a + " ");
            }
            else
            Console.WriteLine("NE");
        }

        
    }
    static void Main()
    {

       int t = int.Parse(Console.ReadLine());
        string[] s = Console.ReadLine().Split();
        long n = long.Parse(s[0]);
        long k = long.Parse(s[1]);
        string[] s1 = Console.ReadLine().Split();
        long a = long.Parse(s1[0]);
        
        Funkcija(t, n, k, a);











    }
}